Import mojo
Import monkenlib
Import mojo
Import os

Function Main()

	'Read the configuration, setting the target, list of banned functions and list of renamed functions
	Local configsection=0
	Local Config:MStream = new MStream("config.txt")
	While Not EOF(Config)
	
		Local keyvalue:String[] = Config.ReadLine().Split(":")
		if(keyvalue[0].StartsWith("'")) Continue
		
		Select(keyvalue[0].ToLower())
			Case "target"
				Target = keyvalue[1]
				Continue
			Case "banned"
				configsection = 1
				Continue
			Case "renamed"
				configsection = 2
				Continue
		End
		
		Select(configsection)
			Case 1
				Banned.Insert(keyvalue[0])	
			Case 2
				Renamed.Add(keyvalue[0].Split("=")[0],keyvalue[0].Split("=")[1])
		End
		
	Wend
	
	'Read the target file
	Local targetStream:MStream = new MStream("in\"+Target)
	Local insideLines:=new List<string>()
	Local outsideLines:=new List<string>()
	Local outsideLayer:int
	Local classes:=New List<String>()
	Local variables:=new StringMap<StringObject>()
	While Not EOF(targetStream)
		
		Local line:String = targetStream.ReadLine()
		
		if(line.Trim.ToLower="end")
			Continue
		EndIf
		
		'Begin with syntax corrections
		'Comment out code with banned lines
		For Local ban:String = eachin Banned
			if FindMatch(line,ban)=True
				line = "'WARNING - This line contains a banned function - " + line
				Continue
			EndIf
		Next
		
		'Correct module names
		For Local key:String = eachin Renamed.Keys
			Local newmodule:String = Renamed.Get(key)
			if(FindMatch(line,key))
				line = line.Replace(key,newmodule)
			EndIf
		Next
		
		'Correct misc
		line = line.Replace(":+","+=").Replace(":-","-=").Replace(":*","*=").Replace(":/","/=")
		line = line.Replace("TList","List<MObject>").Replace("tlist","List<MObject>").Replace("Tlist","List<MObject>")
		line = line.Replace("TImage","Image")
		if(line.ToLower.Contains("local")=False And line.ToLower.Contains("global")=False And line.ToLower.Contains("field")=False And line.ToLower.Contains("function")=False And line.ToLower.Contains("method")=false)
			line = line.Replace("#","").Replace("$","")
		Else
			line = line.Replace("#",":Float").Replace("$",":String")
		EndIf
		
		'Decide if the line goes into OnLoading, or if it goes outside of the Functions
		Local linetype:String = line.Trim().ToLower()
		
		'Record variables for later reference
		if(linetype.StartsWith("global") or linetype.StartsWith("local") or linetype.StartsWith("field") And line.Contains(":"))
			Local linesplit:String[] = line.Trim().Replace(":"," ").Replace("="," ").Split(" ")
			if(linesplit.Length>2)
				variables.Set(linesplit[1],linesplit[2])
			Else
				variables.Set(linesplit[1],"int")
			EndIf
		EndIf
		
		if(outsideLayer>0 or linetype.StartsWith("global") or linetype.StartsWith("const") or linetype.StartsWith("class") or linetype.StartsWith("end class") or linetype.StartsWith("function") or linetype.StartsWith("end function"))
		
			'Class management
			if(linetype.StartsWith("class"))
			
				if(line.ToLower.Contains("extends")=False)
					line += " extends MObject"
				EndIf
				outsideLines.AddLast(line)
				
				Local classname:String = line.Trim().Split(" ")[1]
				classes.AddLast(classname)
				outsideLines.AddLast("Method As"+classname+":"+classname+"()")
				outsideLines.AddLast("Return Self")
				outsideLines.AddLast("End Method")
				
			'Each in management
			ElseIf(line.ToLower.Contains("eachin"))	
			
				local linesplit:String[] = line.Replace("="," ").Replace("   "," ").Split(" ")
				Local variableName:String = linesplit[1]
				Local listName:String = linesplit[3]
					
				outsideLines.AddLast("For local thisObject:MObject = eachin " + listName)
				outsideLines.AddLast("if thisObject.As" + variables.Get(variableName) + "()=null Continue")
				outsideLines.AddLast("local " + variableName + ":" + variables.Get(variableName) + " = thisObject.As" + variables.Get(variableName) + "()")
				
			Else
			
				outsideLines.AddLast(line)
				
			EndIf
		
		else
		
			insideLines.AddLast(line)
			
		EndIf
				
		if(linetype.StartsWith("class") or linetype.StartsWith("function"))
			outsideLayer += 1
		EndIf
		if(linetype.StartsWith("end class") or linetype.EndsWith("end function"))
			outsideLayer -= 1
		EndIf
		
	Wend
	
	'Now that the inside and outside lines have been defined, process the template
	Local templateStream:MStream = new MStream("template.monkey")
	Local outLines := new List<String>()
	While Not EOF(templateStream)
		Local templateLine:String = templateStream.ReadLine()
		if(templateLine="[oncreate]")
			For Local insideline:String = eachin insideLines
				outLines.AddLast(insideline)
			Next
		ElseIf(templateLine="[mobject]")
			For Local classname:String = eachin classes
				outLines.AddLast("Method As"+classname+":"+classname+"()")
				outLines.AddLast("Return null")
				outLines.AddLast("End Method")
			Next
		Else
			outLines.AddLast(templateLine)
		EndIf
	Wend
	
	For Local outsideline:String = eachin outsideLines
		outLines.AddLast(outsideline)
	Next
	
	'Finally, save the file
	Local outLine:String
	for Local line:String = eachin outLines
		outLine += line.Trim() + "~r"
	Next
	SaveString(outLine,"out\"+Target.Replace(".bmx",".monkey"))
	
	
End

Function FindMatch:Bool(source:String,contains:String)

	source = source.Trim().ToLower()
	contains = contains.Trim().ToLower()
	if(source.Contains(contains + " ")) Return True
	if(source.Contains(contains + "(")) Return True
	if(source.EndsWith(" " + contains)) Return True
	if(source=contains) Return True
	Return False

End Function

Global Target:String
Global Banned:=new StringSet()
Global Renamed:=new StringMap<StringObject>()